﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Net.Sockets;
using System.Threading;
using System.Net;

namespace EtherIOProTCP
{

   
    
    public partial class Form1 : Form
    {
        public TcpListener tcpListener = new TcpListener(IPAddress.Any, 2424);
        private Thread listenThread;
        public TcpClient client = null;



        int _EEReadDelay;
        bool _ReadingEE = false;

        UdpClient _udp;

        IPAddress _deviceIP;
        int _devicePort;
        IPEndPoint _deviceEP;

        Thread clientThread;

        private bool _scanned;
        const int dmNormal = 0;
        const int dmDiagnostics = 1;
        int iDisplayMode = dmNormal;
        
        public Form1()
        {
            InitializeComponent();

            _EEReadDelay = 10;
            _scanned = false;
            _devicePort = 2424;
            _udp = new UdpClient(AddressFamily.InterNetwork);   // uses random outgoing port

        }
      
           
        private void ListenForClients()
        {

            try
            {
                this.tcpListener.Start();
            }

            catch
            {
                //this.tcpListener.
            }

            while (true)
            {
                //blocks until a client has connected to the server
                TcpClient client = this.tcpListener.AcceptTcpClient();

                //create a thread to handle communication
                //with connected client
                System.Diagnostics.Debug.WriteLine("Client Connected");
                clientThread = new Thread(new ParameterizedThreadStart(HandleClientComm));
                clientThread.Start(client);
            }
        }



        private void HandleClientComm(object client)
        {
            TcpClient tcpClient = (TcpClient)client;
            NetworkStream clientStream = tcpClient.GetStream();

            byte[] message = new byte[4096];
            int bytesRead;

            while (true)
            {
                bytesRead = 0;

                try
                {
                    //blocks until a client sends a message
                    bytesRead = clientStream.Read(message, 0, 4096);
                }
                catch
                {
                    System.Diagnostics.Debug.WriteLine("catch");
                    //a socket error has occured
                    break;
                }

                if (bytesRead == 0)
                {
                    //the client has disconnected from the server
                    System.Diagnostics.Debug.WriteLine("Client Disconnected");
                    break;
                }

                //message has successfully been received
                ASCIIEncoding encoder = new ASCIIEncoding();
                System.Diagnostics.Debug.WriteLine(encoder.GetString(message, 0, bytesRead));
            }

            tcpClient.Close();
        }


        private void Form1_Load(object sender, EventArgs e)
        {
            System.Diagnostics.Debug.WriteLine("Entering Form1_Load");

            this.listenThread = new Thread(new ThreadStart(ListenForClients));
            this.listenThread.Start();

           

        }

        private void Form1_Activated(object sender, EventArgs e)
        {
            if (!_scanned)
            {
                _scanned = true;
                Module_Scan(null, null);
            }
        }

        //private void Search_IO24_TCP_Click(object sender, EventArgs e)
        //{
        //    TcpClient client = new TcpClient();

        //    IPEndPoint serverEndPoint = new IPEndPoint(IPAddress.Parse("192.168.1.103"), 2424);
        //    try
        //    {
        //        client.Connect(serverEndPoint);
        //    }
        //    catch (SocketException)
        //    {
               
        //    }

        //    NetworkStream clientStream = client.GetStream();

        //    ASCIIEncoding encoder = new ASCIIEncoding();
        //    byte[] buffer = encoder.GetBytes("IO24");

        //    clientStream.Write(buffer, 0, buffer.Length);
        //    clientStream.Flush();
            
        //}





        /// <summary>
        /// scan for IO24 modules
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void Module_Scan(object sender, EventArgs e)
        {
            tsbSearch.Enabled = false;

            // remove any existing drop-down items
            tsddModules.DropDownItems.Clear();
            tsddModules.Text = "No modules found";
            enableModuleItems(false);

            // broadcast "who's there"
            _udp.EnableBroadcast = true;
            _deviceIP = IPAddress.Parse("255.255.255.255");
            IPEndPoint ep = new IPEndPoint(_deviceIP, _devicePort);
            byte[] dgram = Encoding.UTF8.GetBytes("IO24");
            try
            {
                // send query packet
                _udp.Send(dgram, dgram.Length, ep);

                // wait for data
                waitForData(1000);
            }
            catch { }

            tsbSearch.Enabled = true;
        }



 
        /// <summary>
        /// set enabled status of Read/Write/Reboot options
        /// </summary>
        /// <param name="enabled"></param>
        private void enableModuleItems(bool enabled)
        {
            btnTCPTest.Enabled = enabled;
            cbGPIOPort.Enabled = enabled;
            btnTCPReadPort.Enabled = enabled;
          //  btnReadCH0.Enabled = enabled;
          //  btnSetDAChannels.Enabled = enabled;
         //   tbDAVoltTCP.Enabled = enabled;

         //   btnGPIOTestUDP.Enabled = enabled;
         //   btnReadCH0UDP.Enabled = enabled;
        //    btnSetDAChannelsUDP.Enabled = enabled;
         //   tbDAVoltUDP.Enabled = enabled;
         //   btGPIOTest8Bit.Enabled = enabled;

         //   bnEEWrite.Enabled = enabled;
         //   cbEERead.Enabled = enabled;
        }

        /// <summary>
        /// wait until data received or timeout has occured
        /// </summary>
        /// <param name="timeout"></param>
        private bool waitForData(double timeout)
        {
            tmrCheckAvailable.Stop();

            if (_udp == null)
                return false;

            bool rslt = false;

            DateTime now = DateTime.Now;
            while (!rslt && DateTime.Now < now.AddMilliseconds(timeout))
            {
                if (_udp != null && _udp.Available >= 4)
                {
                    processUDPdata();
                    rslt = true;
                }
            }

            tmrCheckAvailable.Start();

            return rslt;
        }

        private void tmrCheckAvailable_Tick(object sender, EventArgs e)
        {
            if (_udp == null)
                return;
            else
                waitForData(10);
        }


        /// <summary>
        /// process any UDP data waiting
        /// </summary>
        private void processUDPdata()
        {
            if (_udp != null)
            {
                // loop while there is data to collect
                while (_udp.Available > 0)
                {
                    IPEndPoint ep = new IPEndPoint(IPAddress.Parse("255.255.255.255"), 0);
                    byte[] data = _udp.Receive(ref ep);
                    string ipAddress = ep.Address.ToString();
                    string text = Encoding.UTF8.GetString(data);

                    if (data.Length < 4)
                    {
                        _EEReadDelay += 10;
//                        debug.WriteLine("Short packet from {0}\r\nEEReadDelay increased to {1}\r\n", ipAddress, _EEReadDelay);
                    }
                    // check if this is an IO24 announcement
                    else if (text.Length > 4 && text.Substring(0, 4) == "IO24")
                    {
                        // only display information from modules
                        if (data.Length > 4)
                        {
                            if (!_ReadingEE)
                            {
                                // retrieve module information
                                string id = string.Format("{0} - MAC {1}:{2}:{3}:{4}:{5}:{6} V{7}.{8}",
                                    ipAddress,
                                    data[4].ToString("X2"), data[5].ToString("X2"), data[6].ToString("X2"), data[7].ToString("X2"), data[8].ToString("X2"), data[9].ToString("X2"),
                                    data[10], data[11]);

                                // add to list
                                ToolStripDropDownItem itm = new ToolStripMenuItem(id, null, new EventHandler(Module_Select));
                                itm.Tag = ep.Address.ToString();
                                tsddModules.DropDownItems.Add(itm);
                                tsddModules.Text = string.Format("{0} modules found", tsddModules.DropDownItems.Count);
                            }
                        }

                        // pause to allow time for other modules to respond
                        if (_udp.Available == 0)
                            System.Threading.Thread.Sleep(100);
                    }
                    else if (_deviceIP.ToString() != ipAddress)
                    {
                        // if message is not from the device we are addressing, 
                        // exit this loop (do nothing)
//                        debug.WriteLine("Response from {0}", ipAddress);
                    }
                    //else if (data.Length == 4)
                    //{
                    //    // check if reading
                    //    if (data[0] == 'R' && !_EEWriteFlag)
                    //    {
                    //        /******************************************************************************************************
                    //         * READING EEPROM data from module
                    //         *****************************************************************************************************/
                    //        if (_EEAddress == data[1])
                    //        {
                    //            _EEVal[_EEAddress * 2 + 1] = data[2];
                    //            _EEVal[_EEAddress * 2] = data[3];
                    //            _EEReadSuccess = true;
                    //        }
                    //    }

                    //    // check if writing data to EEPROM
                    //    else if (_EEWriteFlag)
                    //    {
                    //        /******************************************************************************************************
                    //         * WRITING EEPROM data to module
                    //         *****************************************************************************************************/
                    //        if (_EEAddress == data[1] && _EEData == (data[2] * 256 + data[3]))
                    //        {
                    //            _EEAddress++;
                    //            _EEWriteSuccess = true;
                    //        }
                    //        else
                    //        {
                    //            _EEWriteSuccess = false;
                    //            disableWrite();
                    //            MessageBox.Show(string.Format("EEPROM Write Fail\nat Address {0}", _EEAddress),
                    //                "EEPROM Write", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);

                    //            _EEWriteFlag = false;
                    //        }

                    //        if (_EEAddress < 63)
                    //        {
                    //            pbWriteStatus.Value = _EEAddress;
                    //            _EEData = _EEVal[_EEAddress * 2 + 1] * 256 + _EEVal[_EEAddress * 2];

                    //            writeEEbyte(_EEAddress, _EEData);
                    //            while (!readEEByte(_EEAddress)) ;
                    //        }
                    //        else if (_EEWriteSuccess)
                    //        {
                    //            disableWrite();
                    //            pbWriteStatus.Value = pbWriteStatus.Maximum;

                    //            MessageBox.Show("EEPROM Write Successful",
                    //                "EEPROM Write", MessageBoxButtons.OK, MessageBoxIcon.Information);

                    //            _EEWriteFlag = false;
                    //            pbWriteStatus.Value = 0;
                    //        }
                    //    }
                    //}
                    //else
                    //{
                    //    /******************************************************************************************************
                    //     * EEPROM data
                    //     *****************************************************************************************************/
                    //    bool auto_read = false;
                    //    int byte_counter = 0;
                    //    int data_format = 0;
                    //    int sub_format = 0;
                    //    byte read_value = 0;
                    //    byte last_read = 0;
                    //    char ch = '\0';

                    //    // read through all data in packet
                    //    for (int n = 0; n < data.Length; n++)
                    //    {
                    //        read_value = data[n];
                    //        ch = (char)read_value;

                    //        switch (ch)
                    //        {
                    //            case '*':
                    //                auto_read = true;
                    //                break;

                    //            case '!':
                    //                sub_format = 1;
                    //                break;

                    //            case '@':
                    //                sub_format = 2;
                    //                break;

                    //            case '#':
                    //                sub_format = 3;
                    //                break;

                    //            case '$':
                    //                sub_format = 4;
                    //                break;

                    //            default:
                    //                if (data_format == 0)
                    //                {
                    //                    // new packet of data
                    //                    switch (ch)
                    //                    {
                    //                        case 'A':
                    //                            data_format = 1;
                    //                            break;

                    //                        case 'B':
                    //                            data_format = 2;
                    //                            break;

                    //                        case 'C':
                    //                            data_format = 3;
                    //                            break;

                    //                        case '%':
                    //                            data_format = 4;
                    //                            byte_counter = 1;
                    //                            break;
                    //                    }
                    //                }
                    //                else
                    //                {
                    //                    // update information based on format
                    //                    switch (data_format)
                    //                    {
                    //                        case 1:
                    //                            setPortA(sub_format, read_value, auto_read);
                    //                            data_format = 0;
                    //                            sub_format = 0;
                    //                            break;

                    //                        case 2:
                    //                            setPortB(sub_format, read_value, auto_read);
                    //                            data_format = 0;
                    //                            sub_format = 0;
                    //                            break;

                    //                        case 3:
                    //                            setPortC(sub_format, read_value, auto_read);
                    //                            data_format = 0;
                    //                            sub_format = 0;
                    //                            break;

                    //                        case 4:
                    //                            if (_AutoLoadTarget)
                    //                                setAutoLoad(byte_counter, read_value, ref last_read);

                    //                            // increment data pointer
                    //                            if (++byte_counter > 15)
                    //                            {
                    //                                // we are done
                    //                                _AutoLoadTarget = false;
                    //                                data_format = 0;
                    //                                sub_format = 0;
                    //                            }
                    //                            break;
                    //                    }
                    //                }
                    //                break;
                    //        }

                    //    }
                    //}
                }
            }
        }





        /// <summary>
        /// set target device as selected module
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void Module_Select(object sender, EventArgs e)
        {
            // update toolbar
            ToolStripMenuItem itm = (ToolStripMenuItem)sender;
            tsddModules.Text = itm.Text;
            enableModuleItems(true);

            // capture IP Address
            lDeviceIP.Text = (string)itm.Tag;
            _deviceIP = IPAddress.Parse(lDeviceIP.Text);
            _deviceEP = new IPEndPoint(_deviceIP, _devicePort);
            Application.DoEvents();

            // request EEPROM info
//            Module_Read(sender, e);
        }

        private Boolean TCPConnect()
        {
            if (client == null)
            {
                client = new TcpClient();

                IPEndPoint serverEndPoint = new IPEndPoint(_deviceIP, _devicePort);
                try
                {
                    client.Connect(serverEndPoint);
                    TestTextBox.AppendText("\r\n" + "~~~" + "\r\n");
                    TestTextBox.AppendText("TCP Client Connected to " + lDeviceIP.Text + "\r\n");
                    client.NoDelay = true;
                }
                catch (SocketException)
                {

                }
                return true;
            }
            else
            {
                try
                {
                    client.Close();
                    client = null;
                    TestTextBox.AppendText("TCP Client Disconnected" + "\r\n");

                }
                catch (SocketException)
                {

                }

                return false;
            }
        }

        private void TCPDisconnect()
        {
            client.Close();
            client = null;
            TestTextBox.AppendText("TCP Client Disconnected" + "\r\n");
        }

        private void btnTCPTest_Click(object sender, EventArgs e)
        {
           
            //TCP connection will remain open until the button is pressed again
            
            if (!TCPConnect())
                return;

          

            NetworkStream clientStream = client.GetStream();

            byte[] outBuffer = new byte[16];
            byte[] inBuffer = new byte[16];
            //byte inBufferCount = 0;

            byte port = (byte)'A';

            if (cbGPIOPort.Text == "Port A")
                port = (byte)'A';
            else if (cbGPIOPort.Text == "Port B")
                port = (byte)'B';
            else if (cbGPIOPort.Text == "Port C")
                port = (byte)'C';

            outBuffer[0] = (byte)'!';
            outBuffer[1] = (byte)port;
            outBuffer[2] = (byte)0x00;
            clientStream.Write(outBuffer, 0, 3);
            clientStream.Flush();

            TestTextBox.AppendText("Set direction to output" + "\r\n");

            //Initialise Port Values for GPIO Board
            // Set up SPI pins, CS and INT pins
            outBuffer[0] = (byte)port;
            outBuffer[1] = (byte)0xFF;//Enable the CS_n for GPIO to idle state (1001 1001)
            clientStream.Write(outBuffer, 0, 2);
            clientStream.Flush();

            Application.DoEvents();

            TestTextBox.AppendText("Set Port to all high" + "\r\n");

            //Close TCP Connection
            TCPDisconnect();

        }

        private void btnTCPReadPort_Click(object sender, EventArgs e)
        {
           
            if (!TCPConnect())
                return;
            
            NetworkStream clientStream = client.GetStream();

            byte[] outBuffer = new byte[16];
            byte[] inBuffer = new byte[16];
            byte inBufferCount = 0;

            byte port = (byte)'A';

            if (cbGPIOPort.Text == "Port A")
                port = (byte)'a';
            else if (cbGPIOPort.Text == "Port B")
                port = (byte)'b';
            else if (cbGPIOPort.Text == "Port C")
                port = (byte)'c';

            outBuffer[0] = (byte)port;
            clientStream.Write(outBuffer, 0, 1);
            clientStream.Flush();

            TestTextBox.AppendText("Read Port" + "\r\n");

            // Read bytes back from stream
            System.Threading.Thread.Sleep(100);
            inBufferCount = 0;
            do
            {
                inBuffer[inBufferCount++] = (byte)clientStream.ReadByte();
            } while (clientStream.DataAvailable);


            if (inBuffer[0] == 0x41) //we are dealing with Port Read
            {
               TestTextBox.AppendText("Port A = " +inBuffer[1].ToString("X2") + "\r\n");
            }
            else if (inBuffer[0] == 0x42)
            {
                TestTextBox.AppendText("Port B = " + inBuffer[1].ToString("X2") + "\r\n");
            }
            else if (inBuffer[0] == 0x43)
            {
                TestTextBox.AppendText("Port C = " + inBuffer[1].ToString("X2") + "\r\n");
            }

            //Close TCP Connection
            TCPDisconnect();
      
        }

        private void Form1_FormClosed(object sender, FormClosedEventArgs e)
        {
            this.listenThread.Abort();
            this.tcpListener.Stop();
        }

       

        

       

        





















    }

   

}
